Unit MLU41_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure MLU41(var TETA :Real; var L :Integer; K :Integer;
                var XK :Array of Real; M :Integer;
                var ALFA :Array of Real; KV :Integer;
                var NALFA :Array of Integer; NA :Integer;
                var X :Array of Real; var NX :Array of Integer;
                var NW :Array of Integer; var KW :Integer);

implementation

procedure MLU41(var TETA :Real; var L :Integer; K :Integer;
                var XK :Array of Real; M :Integer;
                var ALFA :Array of Real; KV :Integer;
                var NALFA :Array of Integer; NA :Integer;
                var X :Array of Real; var NX :Array of Integer;
                var NW :Array of Integer; var KW :Integer);
var
K1,I,I1 :Integer;
const
O001 :Real = 0.001;
O16000 :Integer = 16000;
label
_6,_1,_7,_2,_3,_4,_8,_5;
begin
{      KOPPEKTPOBKA BEKTOPA ALFA }
if ( L < O16000 )
 then goto _6;
TETA := -TETA;
L := L-O16000;
if ( L = 0 )
 then goto _2;
_6:
if ( XK[L-1] > 0.0 )
 then goto _7;
K1 := NX[L-1];
for I:=1 to KV do
 begin
  I1 := NALFA[I-1];
  if ( I1 <> K1 )
   then goto _1;
  I1 := I1+16000;
  NALFA[I-1] := I1;
_1:
 end;
_7:
if ( TETA >= 0.0 )
 then goto _4;
_2:
for I:=1 to M do
 begin
_3:
  XK[I-1] := -XK[I-1];
 end;
_4:
K1 := K;
if ( TETA >= 0.0 ) and ( L = 0 )
 then K1 := K+16000;
if ( TETA < 0.0 ) or ( L = 0 )
 then NALFA[NA-1] := K1;
if ( Abs(TETA) > O001 )
 then goto _8;
KW := KW+1;
NW[KW-1] := K;
goto _5;
_8:
KW := 0;
_5:
end;

end.
